function MailClassifierController(accounts){
	this.msgaccount=new Array();
	this.accounts=new Array();
	this.addedFolders=new Array();
	var numServers = accounts.Count();
        var index = 0;
	this.classifyMessage=function(msgURI,account){
		var acc=this.getAccount(account);
		var msg=new Message(msgURI);
		if(acc){
		acc.classifyMessage(msg);
		}
	}
	this.forceClassify=function(msgURI,account){
		var acc=this.getAccount(account);
		var msg=new Message(msgURI);
		if(acc){
			acc.forceClassify(msg);
		}		
	}
	this.unclassifyMessage=function(msgURI,account){
		var acc=this.getAccount(account);
		if(acc) acc.unclassifyMessage(msgURI);
	}
	this.getFirstMessageClassification=function(msgURI){
		var acc=this.msgaccount[msgURI];
		if(!acc) return null;
		var classf=acc.getClassificationFor(msgURI);
		if(!classf) return null;
		var best=classf.getBest();
		if(!best) return null; 
		return best.mozillaFolder;
	}
	this.setAccountForURI=function(msgURI,account){
		this.msgaccount[msgURI]=account;
	}
	this.getClassifications=function(msgURI){
		var acc=this.msgaccount[msgURI];
		if(!acc) return null;
		var classf=acc.getClassificationFor(msgURI);
		if(!classf) return null;
		var cfs=classf.getClassifications();
		var ret=new Array();
		for(i=0;i<cfs.length;i++){
			ret.push(cfs[i].uFolder);
		}
		return ret;
	}
	this.getUFolders=function(account){
		var acc=this.getAccount(account);
		if(acc) return acc.uFolders;
		return null;
	}
	this.addFolder=function(mozFolder){
		var server=mozFolder.server;
		var acc=this.getAccount(server);
		if(acc){
			 acc.addFolderToClassifications(mozFolder);
		}
	}
	this.removeFolder=function(mozFolder){
		var server=mozFolder.server;
		var acc=this.getAccount(server);
		if(acc){
			acc.removeFolderFromClassifications(mozFolder);
		}
	}	
	this.addAccount=function(account){
		if(account.type=="pop3" || account.type=="imap" 
		|| account.type=="none"){
			var acc=new Account(account,this);
			this.accounts[account]=acc;
			return acc;
		}
		return null;
	}
	this.getAccount=function(account){
		var acc=this.accounts[account];
		if(acc) return acc;
		return this.addAccount(account);
	}
	this.removeAccount=function(account){

	}
	this.update=function(msgURI,mozFolder){
		
	}
	this.shutdown=function(){
		for (var i= 0; i < this.accounts.length; i++){
			this.accounts[i].shutdown();
		}		
	}
	this.setClassification=function(msgURI,folder){
		var acc=this.accounts[folder.server];
		if(acc){
			acc.setClassification(msgURI,folder);
		}
	}
	for (index = 0; index < numServers; index++){
		var currentServer = accounts.GetElementAt(index).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
		this.addAccount(currentServer);
	}
}
